#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Symbol.ico
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****
#NoTrayIcon
#include <GDIP.au3>
#include <WinAPI.au3>
#include <Misc.au3>
#include <Array.au3>
If _Singleton("Starter") = 0 Then Exit
Global $sTitle = "Starter", $iWidth = 820, $iHeight = 179, $sSettings = "Settings.ini", $sProgramSection = "Programs"
$aRead = IniReadSection(@ScriptDir & "\" & $sSettings, $sProgramSection)
If @error Then Exit
For $i = 7 To UBound($aRead) - 1 Step 6
	$iHeight += 164
Next
$hGUI = GUICreate($sTitle, $iWidth, $iHeight, -1, @DesktopHeight - $iHeight - 35, 0x80000000, 0x00000008)
$hRect = _WinAPI_CreateRoundRectRgn(0, 0, $iWidth, $iHeight, 30, 30)
_WinAPI_SetWindowRgn($hGUI, $hRect)
_GDIPlus_Startup()
$hGraphics = _GDIPlus_GraphicsCreateFromHWND($hGUI)
$hBitmap = _GDIPlus_BitmapCreateFromGraphics($iWidth, $iHeight, $hGraphics)
$hBuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)
$hBrush = _GDIPlus_BrushCreateSolid(0xFFFFFFFF)
$hBrush2 = _GDIPlus_BrushCreateSolid(0x55666666)
$hFormat = _GDIPlus_StringFormatCreate()
$hFamily = _GDIPlus_FontFamilyCreate("Arial")
$hFont = _GDIPlus_FontCreate($hFamily, 10, 1)
_GDIPlus_StringFormatSetAlign($hFormat, 1)
$iLeft = 11
$iTop = 11
Dim $aArray[1][6]
For $i = 1 To $aRead[0][0]
	ReDim $aArray[$i][6]
	$aSplit = StringSplit($aRead[$i][1], ";")
	$aArray[$i - 1][0] = $aSplit[1]
	$aArray[$i - 1][1] = $iLeft
	$aArray[$i - 1][2] = $iTop
	$aArray[$i - 1][3] = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\" & "Icons\" & $aSplit[2])
	$aArray[$i - 1][4] = $aSplit[3]
	$aArray[$i - 1][5] = $aSplit[2]
	$iLeft += 134
	If $iLeft = 815 Then
		$iLeft = 11
		$iTop += 164
	EndIf
Next
GUISetBkColor(0x666666)
WinSetTrans($sTitle, "", 0)
GUISetState()
Show()
While GUIGetMsg() <> -3
	_GDIPlus_GraphicsClear($hBuffer, 0xFF666666)
	$aInfo = GUIGetCursorInfo($hGUI)
	For $i = 0 To UBound($aArray) - 1
		_GDIPlus_GraphicsDrawImageRect($hBuffer, $aArray[$i][3], $aArray[$i][1], $aArray[$i][2], 128, 128)
		$hLayout = _GDIPlus_RectFCreate($aArray[$i][1], $aArray[$i][2] + 128, 128, 30)
		_GDIPlus_GraphicsDrawStringEx($hBuffer, $aArray[$i][0], $hFont, $hLayout, $hFormat, $hBrush)
		If $aInfo[0] >= $aArray[$i][1] And $aInfo[0] <= $aArray[$i][1] + 128 And $aInfo[1] >= $aArray[$i][2] And $aInfo[1] <= $aArray[$i][2] + 148 Then
			_GDIPlus_GraphicsFillRect($hBuffer, $aArray[$i][1], $aArray[$i][2], 128, 128, $hBrush2)
			If _IsPressed(2) Then
				If $aArray[$i][4] <> "Add" Then
					$hGUI2 = GUICreate("Bearbeiten", 274, 170, -1, -1, Default, 0x00000008)
					GUISetFont(10, 400, 0, "Verdana")
					GUICtrlCreateLabel("Name:", 8, 10, 46, 20)
					GUICtrlCreateLabel("Icon:", 8, 42, 39, 20)
					GUICtrlCreateLabel("Pfad:", 8, 74, 39, 20)
					$hInput1 = GUICtrlCreateInput($aArray[$i][0], 64, 8, 201, 24)
					$hInput2 = GUICtrlCreateInput($aArray[$i][5], 64, 40, 168, 24)
					$hInput3 = GUICtrlCreateInput($aArray[$i][4], 64, 72, 168, 24)
					$hButton1 = GUICtrlCreateButton("^", 232, 40, 35, 25)
					$hButton2 = GUICtrlCreateButton("^", 232, 72, 35, 25)
					$hButton3 = GUICtrlCreateButton("OK", 96, 136, 75, 25)
					$hButton4 = GUICtrlCreateButton("Abbrechen", 176, 136, 91, 25)
					$hButton5 = GUICtrlCreateButton("Lschen", 8, 104, 259, 25)
					GUISetState()
					While 1
						Switch GUIGetMsg()
							Case -3
								GUIDelete($hGUI2)
								ExitLoop
							Case $hButton4
								GUIDelete($hGUI2)
								ExitLoop
							Case $hButton3
								$aArray[$i][0] = GUICtrlRead($hInput1)
								_GDIPlus_ImageDispose($aArray[$i][3])
								$aArray[$i][3] = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\" & "Icons\" & GUICtrlRead($hInput2))
								$aArray[$i][4] = GUICtrlRead($hInput3)
								$aArray[$i][5] = GUICtrlRead($hInput2)
								GUIDelete($hGUI2)
								ExitLoop
							Case $hButton1
								$hDialog = FileOpenDialog("Dateipfad", @ScriptDir & "\" & "Icons\", "Alle (*.*)")
								If Not @error Then
									$iString = StringInStr($hDialog, "\", 0, -1)
									$iMid = StringMid($hDialog, $iString + 1)
									GUICtrlSetData($hInput2, $iMid)
								EndIf
							Case $hButton2
								$hDialog = FileOpenDialog("Dateipfad", @ProgramFilesDir, "Alle (*.*)")
								If Not @error Then
									GUICtrlSetData($hInput3, $hDialog)
								EndIf
							Case $hButton5
								_GDIPlus_ImageDispose($aArray[$i][3])
								_ArrayDelete($aArray, $i)
								GUIDelete($hGUI2)
								Close2()
								ExitLoop
						EndSwitch
					WEnd
				EndIf
			EndIf
			If _IsPressed(1) Then
				Do
				Until _IsPressed(1) = False
				$aInfo = GUIGetCursorInfo($hGUI)
				For $a = 0 To UBound($aArray) - 1
					If $aInfo[0] >= $aArray[$a][1] And $aInfo[0] <= $aArray[$a][1] + 128 And $aInfo[1] >= $aArray[$a][2] And $aInfo[1] <= $aArray[$a][2] + 148 Then
						If $i = $a Then
							If $aArray[$a][4] = "Add" Then
								$hGUI2 = GUICreate("Hinzufgen", 274, 138, -1, -1, Default, 0x00000008)
								GUISetFont(10, 400, 0, "Verdana")
								GUICtrlCreateLabel("Name:", 8, 10, 46, 20)
								GUICtrlCreateLabel("Icon:", 8, 42, 39, 20)
								GUICtrlCreateLabel("Pfad:", 8, 74, 39, 20)
								$hInput1 = GUICtrlCreateInput("", 64, 8, 201, 24)
								$hInput2 = GUICtrlCreateInput("", 64, 40, 168, 24)
								$hInput3 = GUICtrlCreateInput("", 64, 72, 168, 24)
								$hButton1 = GUICtrlCreateButton("^", 232, 40, 35, 25)
								$hButton2 = GUICtrlCreateButton("^", 232, 72, 35, 25)
								$hButton3 = GUICtrlCreateButton("OK", 96, 104, 75, 25)
								$hButton4 = GUICtrlCreateButton("Abbrechen", 176, 104, 91, 25)
								GUISetState()
								While 1
									Switch GUIGetMsg()
										Case -3
											GUIDelete($hGUI2)
											ExitLoop
										Case $hButton4
											GUIDelete($hGUI2)
											ExitLoop
										Case $hButton3
											$iBound = UBound($aArray)
											ReDim $aArray[UBound($aArray) + 1][6]
											$aArray[$iBound][0] = GUICtrlRead($hInput1)
											$aArray[$iBound][1] = $iLeft
											$aArray[$iBound][2] = $iTop
											$aArray[$iBound][3] = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\" & "Icons\" & GUICtrlRead($hInput2))
											$aArray[$iBound][4] = GUICtrlRead($hInput3)
											$aArray[$iBound][5] = GUICtrlRead($hInput2)
											GUIDelete($hGUI2)
											Close2()
											ExitLoop
										Case $hButton1
											$hDialog = FileOpenDialog("Dateipfad", @ScriptDir & "\" & "Icons\", "Alle (*.*)")
											If Not @error Then
												$iString = StringInStr($hDialog, "\", 0, -1)
												$iMid = StringMid($hDialog, $iString + 1)
												GUICtrlSetData($hInput2, $iMid)
											EndIf
										Case $hButton2
											$hDialog = FileOpenDialog("Dateipfad", @ProgramFilesDir, "Alle (*.*)")
											If Not @error Then
												GUICtrlSetData($hInput3, $hDialog)
											EndIf
									EndSwitch
								WEnd
							Else
								ShellExecute($aArray[$a][4])
							EndIf
						Else
							Sort($i, $a)
							$iExit = 0
							ExitLoop
						EndIf
					EndIf
				Next
			EndIf
		EndIf
	Next
	_GDIPlus_GraphicsDrawImage($hGraphics, $hBitmap, 0, 0)
WEnd
Close()
Func Sort($10, $11)
	If $10 > $11 Then
		Local $1 = $aArray[$10][0]
		Local $2 = $aArray[$10][1]
		Local $3 = $aArray[$10][2]
		Local $4 = $aArray[$10][3]
		Local $5 = $aArray[$10][4]
		Local $6 = $aArray[$10][5]
		Local $12 = $10 - 1
		Do
			$aArray[$12 + 1][0] = $aArray[$12][0]
			$aArray[$12 + 1][1] = $aArray[$12][1]
			$aArray[$12 + 1][2] = $aArray[$12][2]
			$aArray[$12 + 1][3] = $aArray[$12][3]
			$aArray[$12 + 1][4] = $aArray[$12][4]
			$aArray[$12 + 1][5] = $aArray[$12][5]
			$12 -= 1
		Until $12 = $11 - 1
		$aArray[$11][0] = $1
		$aArray[$11][1] = $2
		$aArray[$11][2] = $3
		$aArray[$11][3] = $4
		$aArray[$11][4] = $5
		$aArray[$11][5] = $6
	EndIf
	$iLeft = 11
	$iTop = 11
	For $i = 0 To UBound($aArray) - 1
		$aArray[$i][1] = $iLeft
		$aArray[$i][2] = $iTop
		$iLeft += 134
		If $iLeft = 815 Then
			$iLeft = 11
			$iTop += 164
		EndIf
	Next

EndFunc   ;==>Sort
Func Close2()
	Dispose()
	Exit ShellExecute(@ScriptFullPath)
EndFunc   ;==>Close2
Func Close()
	Dispose()
	Hide()
	Exit
EndFunc   ;==>Close
Func Show()
	$i = 0
	Do
		$i += 4
		WinSetTrans($sTitle, "", $i)
	Until $i > 251
	WinSetTrans($sTitle, "", 255)
EndFunc   ;==>Show
Func Hide()
	$i = 255
	Do
		$i -= 2
		WinSetTrans($sTitle, "", $i)
	Until $i < 2
EndFunc   ;==>Hide
Func Write()
	IniDelete(@ScriptDir & "\" & $sSettings, $sProgramSection)
	IniWriteSection(@ScriptDir & "\" & $sSettings, $sProgramSection, "")
	For $i = 0 To UBound($aArray) - 1
		IniWrite(@ScriptDir & "\" & $sSettings, $sProgramSection, $i, $aArray[$i][0] & ";" & $aArray[$i][5] & ";" & $aArray[$i][4])
	Next
EndFunc   ;==>Write
Func Dispose()
	Write()
	For $i = 0 To UBound($aArray) - 1
		_GDIPlus_ImageDispose($aArray[$i][3])
	Next
	_GDIPlus_FontDispose($hFont)
	_GDIPlus_FontFamilyDispose($hFamily)
	_GDIPlus_StringFormatDispose($hFormat)
	_GDIPlus_BrushDispose($hBrush)
	_GDIPlus_BrushDispose($hBrush2)
	_GDIPlus_BitmapDispose($hBitmap)
	_GDIPlus_GraphicsDispose($hGraphics)
	_GDIPlus_Shutdown()
EndFunc   ;==>Dispose
